﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;

namespace May_Samples
{
   public class EnumToCustomConverter : EnumToBindableBase
   {
      protected override bool SupportsConvertBack
      { get { return true; } }

      protected override object InternalConvert(Common.IEnumWrapper enumWrapper,
         Type enumType, object value, Type targetType, object parameter,
         System.Globalization.CultureInfo culture)
      { return enumWrapper.EnumToString(value); }

      protected override object InternalConvertBack(Common.IEnumWrapper enumWrapper,
         Type enumType, object value, Type targetType, object parameter,
         System.Globalization.CultureInfo culture)
      { return enumWrapper.StringToEnum(value.ToString()); }
   }
}
