﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Windows.Data;
using Common;

namespace May_Samples
{
   public class EnumToCustomEnumerableConverter : EnumToBindableBase 
   {
      protected override object InternalConvert(IEnumWrapper enumWrapper, 
         Type enumType, object value, Type targetType, object parameter, 
         System.Globalization.CultureInfo culture)
      {
         if (enumWrapper == null)
         {return from x in enumType.GetFields()
                 where !x.IsSpecialName
                 select x.Name;
         }
         return enumWrapper.BindableEnums;
      }

      //[ImportMany]
      //public IEnumerable<Lazy<IEnumWrapper, IEnumWrapperExportMetadata>> _enumWrappers;

      //public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
      //{
      //   if (_enumWrappers == null)
      //   { CompositionInitializer.SatisfyImports(this); }
      //   var enumType = value.GetType();
      //   var lazyWrapper = (from x in _enumWrappers
      //                  where x.Metadata.TargetType == enumType
      //                  select x).FirstOrDefault();
      //   if (lazyWrapper != null)
      //   {
      //      var wrapper = lazyWrapper.Value;
      //      return wrapper.BindableEnums;
      //   }
      //   return from x in enumType.GetFields()
      //          where !x.IsSpecialName
      //          select x.Name;
      //}

      //public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
      //{
      //   throw new NotImplementedException();
      //}
   }
}
