﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;
using System.Linq;

namespace May_Samples
{
   public class EnumToEnumerableConverter : IValueConverter
   {

      public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
      {
         var enumType = value.GetType();
         var _comparisonOperators1 =
            from x in enumType.GetFields()
            where !x.IsSpecialName
            select x.Name;
         return _comparisonOperators1;
      }

      public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
      {
         throw new NotImplementedException();
      }
   }
}
